// my.cpp : Defines the entry point for the console application.
//
#include "MyStream.h"
#include "math.h"
using namespace std;

int ru[3][3]={1,1,1, 1,0,1, 1,1,1};
const int M1=24, N1=32;
int rules(int aa[M1][N1], int m, int n){
  int co=0;
  for(int m1=-1; m1<2; m1++)
  for(int n1=-1; n1<2; n1++)
    co+=!!aa[m+m1][n+n1] * ru[m1+1][n1+1];
  if(!aa[m][n] && co==3)return 1;
  if(!!aa[m][n] && (co<2||co>3))return 0;
  return aa[m][n];
}
int xcopy(int trg[M1][N1], int src[M1][N1]){
  for(int m=0; m<M1; m++)
    for(int n=0; n<N1; n++) 
      trg[m][n]=src[m][n];
  return false;
}
int main()
{  
  myofs.open("protocol.txt");
  myofs << setiosflags(ios::fixed) << setiosflags(ios::right) << setw(10);
  {
  myofs << "Team 123,   . 18  2008 ." << endl; 
  myofs << "  3-15.     " << endl << endl; 
  }
  {
    myofs << " 8.   .  :" << endl;
    const int M=12, N=8; int m, n;
    double a[M][N];
    for(m=0; m<M; m++)
      for(n=0; n<N; n++){
        a[m][n] = m*n;
    }
    for(m=0; m<M; m++){
      for(n=0; n<N; n++){
        myofs << "  a[" << setw(2) << m << "," << setw(2) << n << "]=" << setw(5) << setprecision(1) << a[m][n];
      }
      myofs << endl;
    }
  }
  {
    myofs << " 9.  :" << endl;
    const int M=12, N=12; int m, n;
    double a[M][N];
    for(m=0; m<M; m++)
      for(n=0; n<N; n++){
        a[m][n] = m*n;
    }
      myofs << "    ";
    for(n=0; n<N; n++){myofs << setw(6) << n;} myofs << endl;
    for(m=0; m<M; m++){
      myofs << setw(3) << m << "  ";
      for(n=0; n<N; n++){
        myofs << setw(6) << setprecision(1) << a[m][n];
      }
      myofs << endl;
    }
  }
  {
    myofs << " 10.   " << endl;
    const int M=12, N=8; int m, n, m1, m2, n1, n2;
    double d1, d2, d3, a[M][N];
    double ar1[M], ar2[M], ac1[N], ac2[N];
    int ir1[M], ir2[M], ic1[N], ic2[N];
    for(m=0; m<M; m++)
      for(n=0; n<N; n++){
        a[m][n] = 10.0*((double(rand())/double(RAND_MAX))*2.0-1.0);
    }
    for(m=0; m<M; m++){
      d1=d2=a[m][0]; n1=n2=0;
      for(n=1; n<N; n++){
        d3=a[m][n];
        if(d3<d1){d1=d3; n1=n;}
        if(d3>d2){d2=d3; n2=n;}
      }
      ar1[m]=d1;
      ar2[m]=d2;
      ir1[m]=n1;
      ir2[m]=n2;
    }
    for(n=0; n<N; n++){
      d1=d2=a[0][n]; m1=m2=0;
      for(m=1; m<M; m++){
        d3=a[m][n];
        if(d3<d1){d1=d3; m1=m;}
        if(d3>d2){d2=d3; m2=m;}
      }
      ac1[n]=d1;
      ac2[n]=d2;
      ic1[n]=m1;
      ic2[n]=m2;
    }
    myofs << "                   ";
    for(n=0; n<N; n++){myofs << " [" << setw(2) << ic2[n] << "," << n << "]";} myofs << endl;
    myofs << "                   ";
    for(n=0; n<N; n++){myofs << setw(7) << setprecision(3) << ac2[n];} myofs << endl;
    myofs << "                 ------------------------------------------------------------" << endl;
    for(m=0; m<M; m++){
      myofs << "a[" << setw(2) << m << "," << setw(1) << ir1[m] << "]=" << setw(7) << setprecision(3) << ar1[m] << " || ";
      for(n=0; n<N; n++){
        myofs << setw(7) << setprecision(3) << a[m][n];
      }
      myofs << " || a[" << setw(2) << m << "," << setw(1) << ir2[m] << "]=" << setw(7) << setprecision(3) << ar2[m] << endl;
    }
    myofs << "                 ------------------------------------------------------------" << endl;
    myofs << "                   ";
    for(n=0; n<N; n++){myofs << " [" << setw(2) << ic1[n] << "," << n << "]";} myofs << endl;
    myofs << "                   ";
    for(n=0; n<N; n++){myofs << setw(7) << setprecision(3) << ac1[n];} myofs << endl;
  }
  {
    myofs << " 10.   " << endl;
    const int M=M1; const int N=N1; const int J=64;
    int a[M][N], a1[M][N];
    const int K=10;
    int b[K][K];
    myifs.open("ini.dat");
    for(int m=K-1; m>=0; m--)
      for(int n=0; n<K; n++) 
        myifs >> b[m][n];
    myifs.close();
    myifs.open("rules.dat");
    for(int m=2; m>=0; m--)
      for(int n=0; n<3; n++) 
        myifs >> ru[m][n];
    myifs.close();
    for(int m=0; m<M; m++) for(int n=0; n<N; n++) a[m][n]=0;
    for(int m=0; m<K; m++) for(int n=0; n<K; n++) a[m][n]=b[m][n];
    for(int m=0; m<K; m++) for(int n=0; n<K; n++) a[m][N1-n-1]=b[m][n];
    for(int j=0; j<J; j++)
    {
      myofs << "  =" << j << endl;
      for(int m=M-1; m>=0; m--){
        for(int n=0; n<N; n++)
          if(a[m][n]) myofs << a[m][n];
          else myofs << ".";
          myofs << endl;
      }
      xcopy(a1, a);
      for(int m=1; m<M-1; m++) 
        for(int n=1; n<N-1; n++)
          a[m][n]=rules(a1, m, n);
    }
  }
  myofs.close();
  return 0;
}

